from aws_resource_validator.pydantic_models.base_validator_model import BaseValidatorModel
from botocore.response import StreamingBody
from datetime import datetime
from typing import Any
from typing import Dict
from typing import IO
from typing import List
from typing import Literal
from typing import Mapping
from typing import Optional
from typing import Sequence
from typing import Union
from aws_resource_validator.pydantic_models.ec2_instance_connect_constants import *

class ResponseMetadata(BaseValidatorModel):
    RequestId: str
    HTTPStatusCode: int
    HTTPHeaders: Dict[str, str]
    RetryAttempts: int
    HostId: Optional[str] = None


class SendSSHPublicKeyRequest(BaseValidatorModel):
    InstanceId: str
    InstanceOSUser: str
    SSHPublicKey: str
    AvailabilityZone: Optional[str] = None


class SendSerialConsoleSSHPublicKeyRequest(BaseValidatorModel):
    InstanceId: str
    SSHPublicKey: str
    SerialPort: Optional[int] = None


class SendSSHPublicKeyResponse(BaseValidatorModel):
    RequestId: str
    Success: bool
    ResponseMetadata: ResponseMetadata


class SendSerialConsoleSSHPublicKeyResponse(BaseValidatorModel):
    RequestId: str
    Success: bool
    ResponseMetadata: ResponseMetadata


